diff --git a/pdk_jacinto_08_02_00_21/packages/ti/drv/enet/src/phy/enetphy.c b/pdk_jacinto_08_02_00_21/packages/ti/drv/enet/src/phy/enetphy.c
index 43a70bc..5306e6f 100644
--- a/pdk_jacinto_08_02_00_21/packages/ti/drv/enet/src/phy/enetphy.c
+++ b/pdk_jacinto_08_02_00_21/packages/ti/drv/enet/src/phy/enetphy.c
@@ -93,14 +93,38 @@
 /* ========================================================================== */
 /*                          Function Declarations                             */
 /* ========================================================================== */
+#ifdef ENET_DEBUG_APPS
+/*! \brief Ethernet PHY capabilities string buffer. */
+static char gEnetPhyCapsBuf[ENETPHY_CAPS_BUF_LEN];
 
-#if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_WARN)
-static const char *EnetPhy_getCapsString(uint32_t linkCaps);
-#endif
+/*! \brief Ethernet PHY mode string buffer. */
+static char gEnetPhyModeBuf[ENETPHY_MODE_BUF_LEN];
+
+static const char *EnetPhy_getCapsString(uint32_t linkCaps)
+{
+    snprintf(gEnetPhyCapsBuf, ENETPHY_CAPS_BUF_LEN, "%s%s%s%s%s%s%s",
+             ((linkCaps & ENETPHY_LINK_CAP_FD1000) != 0U) ? "FD1000 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_HD1000) != 0U) ? "HD1000 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_FD100) != 0U) ? "FD100 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_HD100) != 0U) ? "HD100 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_FD10) != 0U) ? "FD10 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_HD10) != 0U) ? "HD10 " : "",
+             ((linkCaps & ENETPHY_LINK_CAP_ALL) == 0U) ? "None" : "");
+
+    return gEnetPhyCapsBuf;
+}
 
-#if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_DEBUG)
 static const char *EnetPhy_getModeString(EnetPhy_Speed speed,
-                                         EnetPhy_Duplexity duplexity);
+                                         EnetPhy_Duplexity duplexity)
+{
+    snprintf(gEnetPhyModeBuf, ENETPHY_MODE_BUF_LEN, "%sbps %s-duplex",
+             (speed == ENETPHY_SPEED_1GBIT) ? "1 G" :
+             (speed == ENETPHY_SPEED_100MBIT) ? "100 M" : "10 M",
+             (duplexity == ENETPHY_DUPLEX_FULL) ? "full" : "half");
+
+    return gEnetPhyModeBuf;
+}
+
 #endif
 
 static EnetPhy_Handle EnetPhy_getHandle(void);
@@ -126,10 +150,10 @@ static void EnetPhy_resetWaitState(EnetPhy_Handle hPhy);
 
 static void EnetPhy_enableState(EnetPhy_Handle hPhy);
 
-static void EnetPhy_setupNway(EnetPhy_Handle hPhy);
-
-static void EnetPhy_setupManual(EnetPhy_Handle hPhy,
-                                bool loopbackEn);
+//static void EnetPhy_setupNway(EnetPhy_Handle hPhy);
+//
+//static void EnetPhy_setupManual(EnetPhy_Handle hPhy,
+//                                bool loopbackEn);
 
 static void EnetPhy_loopbackState(EnetPhy_Handle hPhy);
 
@@ -141,7 +165,7 @@ static void EnetPhy_linkWaitState(EnetPhy_Handle hPhy);
 
 static void EnetPhy_linkedState(EnetPhy_Handle hPhy);
 
-static bool EnetPhy_isNwayCapable(EnetPhy_Handle hPhy);
+//static bool EnetPhy_isNwayCapable(EnetPhy_Handle hPhy);
 
 static uint32_t EnetPhy_getLocalCaps(EnetPhy_Handle hPhy);
 
@@ -170,6 +194,9 @@ static void EnetPhy_showLinkPartnerCompat(EnetPhy_Handle hPhy,
                                           EnetPhy_Speed speed,
                                           EnetPhy_Duplexity duplexity);
 
+extern bool checkLink ( EnetPhy_Handle hPhy );
+extern EnetPhy_FsmState q2112_nwayWait(EnetPhy_Handle hPhy);
+
 /* ========================================================================== */
 /*                            Global Variables                                */
 /* ========================================================================== */
@@ -179,10 +206,12 @@ extern EnetPhy_Drv gEnetPhyDrvGeneric;
 extern EnetPhy_Drv gEnetPhyDrvDp83822;
 extern EnetPhy_Drv gEnetPhyDrvDp83867;
 extern EnetPhy_Drv gEnetPhyDrvVsc8514;
+extern EnetPhy_Drv gEnetPhyDrvQ2112;
 
 /*! \brief All the registered PHY specific drivers. */
 static EnetPhyDrv_Handle gEnetPhyDrvs[] =
 {
+	&gEnetPhyDrvQ2112,     /* Q2112 */
     &gEnetPhyDrvVsc8514,   /* VSC8514 */
     &gEnetPhyDrvDp83822,   /* DP83822 */
     &gEnetPhyDrvDp83867,   /* DP83867 */
@@ -208,20 +237,49 @@ static const char *gEnetPhyStateNames[] =
     "LOOPBACK",
 };
 #endif
-
+#ifdef ENET_DEBUG_APPS
 #if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_WARN)
 /*! \brief Ethernet PHY capabilities string buffer. */
 static char gEnetPhyCapsBuf[ENETPHY_CAPS_BUF_LEN];
-#endif
 
+#endif
 #if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_DEBUG)
 /*! \brief Ethernet PHY mode string buffer. */
 static char gEnetPhyModeBuf[ENETPHY_MODE_BUF_LEN];
 #endif
+#endif
+
 
 /* ========================================================================== */
 /*                          Function Definitions                              */
 /* ========================================================================== */
+static bool EnetPhy_PhyAddrIsQ2112(uint32_t addr)
+{
+    const uint32_t validAddrList[] = {
+        0,1,3,4,5,0xFFFFFFFF
+    };
+    uint32_t addrInList = validAddrList[0];
+    uint32_t loop = 0;
+    uint32_t size = sizeof(validAddrList)/sizeof(validAddrList[0]);
+    bool ret = false;
+
+    while ((loop < size) && (validAddrList[loop] != 0xFFFFFFFF))
+    {
+        addrInList = validAddrList[loop];
+        if (addr == addrInList)
+        {
+            ret = true;
+            // ENETTRACE_VERBOSE("[EnetPhy_PhyAddrIsQ2112]PHY:%d is in Q2112 list!\n", addr);
+            break;
+        }
+        loop++;
+    }
+    if (addrInList == 0xFFFFFFFF || loop == size )
+    {   ///print the notice to add addr to list
+        ENETTRACE_ERR("[EnetPhy_PhyAddrIsQ2112]PHY:%d does not support Q2112, please add to list! \n", addr);
+    }
+    return ret;
+}
 
 void EnetPhy_initCfg(EnetPhy_Cfg *phyCfg)
 {
@@ -728,18 +786,55 @@ int32_t EnetPhy_readC45Reg(EnetPhy_Handle hPhy,
                            uint32_t reg,
                            uint16_t *val)
 {
-    EnetPhy_MdioHandle hMdio = hPhy->hMdio;
-    uint32_t phyGroup = hPhy->group;
-    uint32_t phyAddr = hPhy->addr;
-    int32_t status;
 
-    status = hMdio->readC45(phyGroup, phyAddr, mmd, reg, val, hPhy->mdioArgs);
-    ENETTRACE_ERR_IF(status != ENETPHY_SOK,
-                     "PHY %u: Failed to read MMD %u reg %u: %d\n", phyAddr, mmd, reg, status);
-    ENETTRACE_VERBOSE_IF(status == ENETPHY_SOK,
-                         "PHY %u: MMD %u reg %u val 0x%04x %s\n", phyAddr, mmd, reg, *val);
+	int32_t ret = 0;
+    /*
+     * Register 13:
+     * FUN                       |  Reserved | device address
+     * 15:14                     | 13:5      | 4:0
+     * 01:Data, post increment   |           |
+     *    on writes only         |           |
+     * 10:Data, post increment   |           |
+     *    on reads and writes    |           |
+     * 01:Data, no post          |           |
+     *    increment              |           |
+     * 00 Address                |           |
+    */
 
-    return status;
+    /*
+     * Register 14:
+     * Address/Data
+     * 15:0
+     * If 13.15:14 = 00, then MMD DEVAD¡¯s address register.
+     * Otherwise, MMD DEVAD¡¯s data register as indicated by the
+     * contents of its address register
+    */
+    // write device address  mmd
+    ;
+    if(0 != (EnetPhy_writeReg(hPhy,13,mmd)))
+    {
+    	ret = -1;
+    }
+    //write register address reg
+    else if(0 != (EnetPhy_writeReg(hPhy,14,reg)))
+    {
+    	ret = -2;
+    }
+    //read device address mmd
+    else if(0 != (EnetPhy_writeReg(hPhy,13,0x8000 | mmd)))
+    {
+    	ret = -3;
+    }
+    //read data
+    else if(0 != (EnetPhy_readReg(hPhy,14,val)))
+    {
+    	ret = -4;
+    }
+    else
+    {
+    	ret = 0;
+    }
+    return ret;
 }
 
 int32_t EnetPhy_writeC45Reg(EnetPhy_Handle hPhy,
@@ -747,18 +842,53 @@ int32_t EnetPhy_writeC45Reg(EnetPhy_Handle hPhy,
                             uint32_t reg,
                             uint16_t val)
 {
-    EnetPhy_MdioHandle hMdio = hPhy->hMdio;
-    uint32_t phyGroup = hPhy->group;
-    uint32_t phyAddr = hPhy->addr;
-    int32_t status;
-
-    status = hMdio->writeC45(phyGroup, phyAddr, mmd, reg, val, hPhy->mdioArgs);
-    ENETTRACE_ERR_IF(status != ENETPHY_SOK,
-                     "PHY %u: Failed to write MMD %u reg %u: %d\n", phyAddr, mmd, reg, status);
-    ENETTRACE_VERBOSE_IF(status == ENETPHY_SOK,
-                         "PHY %u: MMD %u reg %u val 0x%04x\n", phyAddr, mmd, reg, val);
+	int32_t ret = 0;
+    /*
+     * Register 13:
+     * FUN                       |  Reserved | device address
+     * 15:14                     | 13:5      | 4:0
+     * 01:Data, post increment   |           |
+     *    on writes only         |           |
+     * 10:Data, post increment   |           |
+     *    on reads and writes    |           |
+     * 01:Data, no post          |           |
+     *    increment              |           |
+     * 00 Address                |           |
+    */
 
-    return status;
+    /*
+     * Register 14:
+     * Address/Data
+     * 15:0
+     * If 13.15:14 = 00, then MMD DEVAD¡¯s address register.
+     * Otherwise, MMD DEVAD¡¯s data register as indicated by the
+     * contents of its address register
+    */
+    // write device address  mmd
+    if(0 != (EnetPhy_writeReg(hPhy,13,mmd)))
+    {
+    	ret = -1;
+    }
+    //write register address reg
+    else if(0 != (EnetPhy_writeReg(hPhy,14,reg)))
+    {
+    	ret = -2;
+    }
+    //write device address mmd
+    else if(0 != (EnetPhy_writeReg(hPhy,13,0x8000 | mmd)))
+    {
+    	ret = -3;
+    }
+    //read device address data
+    else if(0 != (EnetPhy_writeReg(hPhy,14,val)))
+    {
+    	ret = -4;
+    }
+    else
+    {
+    	ret = 0;
+    }
+    return ret;
 }
 
 int32_t EnetPhy_rmwC45Reg(EnetPhy_Handle hPhy,
@@ -802,34 +932,6 @@ void EnetPhy_printRegs(EnetPhy_Handle hPhy)
     }
 }
 
-#if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_WARN)
-static const char *EnetPhy_getCapsString(uint32_t linkCaps)
-{
-    snprintf(gEnetPhyCapsBuf, ENETPHY_CAPS_BUF_LEN, "%s%s%s%s%s%s%s",
-             ((linkCaps & ENETPHY_LINK_CAP_FD1000) != 0U) ? "FD1000 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_HD1000) != 0U) ? "HD1000 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_FD100) != 0U) ? "FD100 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_HD100) != 0U) ? "HD100 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_FD10) != 0U) ? "FD10 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_HD10) != 0U) ? "HD10 " : "",
-             ((linkCaps & ENETPHY_LINK_CAP_ALL) == 0U) ? "None" : "");
-
-    return gEnetPhyCapsBuf;
-}
-#endif
-
-#if (ENET_CFG_TRACE_LEVEL >= ENET_CFG_TRACE_LEVEL_DEBUG)
-static const char *EnetPhy_getModeString(EnetPhy_Speed speed,
-                                         EnetPhy_Duplexity duplexity)
-{
-    snprintf(gEnetPhyModeBuf, ENETPHY_MODE_BUF_LEN, "%sbps %s-duplex",
-             (speed == ENETPHY_SPEED_1GBIT) ? "1 G" :
-             (speed == ENETPHY_SPEED_100MBIT) ? "100 M" : "10 M",
-             (duplexity == ENETPHY_DUPLEX_FULL) ? "full" : "half");
-
-    return gEnetPhyModeBuf;
-}
-#endif
 
 static EnetPhy_Handle EnetPhy_getHandle(void)
 {
@@ -911,10 +1013,8 @@ static void EnetPhy_setNextState(EnetPhy_Handle hPhy,
             break;
     }
 
-    ENETTRACE_DBG("PHY %u: %s -> %s (%u ticks)\n",
+    ENETTRACE_DBG("PHY %u:(%u ticks)\n",
                   hPhy->addr,
-                  gEnetPhyStateNames[hPhy->state.fsmState],
-                  gEnetPhyStateNames[fsmState],
                   timeout);
 
     hPhy->state.fsmState = fsmState;
@@ -1006,6 +1106,7 @@ static void EnetPhy_findingState(EnetPhy_Handle hPhy)
         }
         else
         {
+        	////////////////////lyl1228////////////////
             ENETTRACE_DBG("PHY %u: timed out\n", phyAddr);
             state->timeout = ENETPHY_TIMEOUT_FINDING;
         }
@@ -1053,6 +1154,8 @@ static void EnetPhy_resetWaitState(EnetPhy_Handle hPhy)
         }
         else
         {
+        	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
+
             EnetPhy_phyTimeout(hPhy);
         }
     }
@@ -1061,8 +1164,6 @@ static void EnetPhy_resetWaitState(EnetPhy_Handle hPhy)
 static void EnetPhy_enableState(EnetPhy_Handle hPhy)
 {
     EnetPhy_State *state = &hPhy->state;
-    uint32_t socLinkCaps;
-    uint32_t commonLinkCaps;
 
     Enet_devAssert(!hPhy->phyCfg.isStrapped,
                    "PHY %u: unexpected state for strapped PHY\n", hPhy->addr);
@@ -1074,223 +1175,36 @@ static void EnetPhy_enableState(EnetPhy_Handle hPhy)
     {
         /* Set PHY in normal mode */
         ENETTRACE_DBG("PHY %u: enable\n", hPhy->addr);
-        EnetPhy_rmwReg(hPhy, PHY_BMCR, BMCR_ISOLATE | BMCR_PWRDOWN, 0U);
-
-        /* PHY-specific 'extended' configuration */
-        if ((hPhy->hDrv->config != NULL) &&
-            !hPhy->phyCfg.skipExtendedCfg)
-        {
-            hPhy->hDrv->config(hPhy, &hPhy->phyCfg, hPhy->mii);
-        }
-    }
-
-    /* Find common capabilities among app's, PHY's and SoC's */
-    ENETTRACE_DBG("PHY %u: req caps: %s\n",
-                  hPhy->addr, EnetPhy_getCapsString(hPhy->reqLinkCaps));
-
-    state->phyLinkCaps = EnetPhy_getLocalCaps(hPhy);
-    ENETTRACE_DBG("PHY %u: PHY caps: %s\n",
-                  hPhy->addr, EnetPhy_getCapsString(state->phyLinkCaps));
-
-    socLinkCaps = hPhy->macCaps;
-    ENETTRACE_DBG("PHY %u: MAC caps: %s\n",
-                  hPhy->addr, EnetPhy_getCapsString(socLinkCaps));
-
-    commonLinkCaps = hPhy->reqLinkCaps &
-                     state->phyLinkCaps &
-                     socLinkCaps;
-    ENETTRACE_DBG("PHY %u: refined caps: %s\n",
-                  hPhy->addr, EnetPhy_getCapsString(commonLinkCaps));
-
-    if (commonLinkCaps != 0U)
-    {
-        state->linkCaps = commonLinkCaps;
-
-        /* Enable NWAY if requested by app (via auto-speed or auto-duplex) and
-         * supported by PHY */
-        state->isNwayCapable = EnetPhy_isNwayCapable(hPhy);
-        ENETTRACE_DBG("PHY %u: PHY is %sNWAY-capable\n",
-                      hPhy->addr, state->isNwayCapable ? "" : "not ");
-
-        state->enableNway = (hPhy->linkCfg.speed == ENETPHY_SPEED_AUTO) ||
-                            (hPhy->linkCfg.duplexity == ENETPHY_DUPLEX_AUTO);
-        if (state->enableNway && !state->isNwayCapable)
+        //////lyl1228//////////////for q2112 only///////////////////
+        if(EnetPhy_PhyAddrIsQ2112(hPhy->addr))
         {
-            /* If PHY is not capable of auto negotiation, fallback to manual mode
-             * with the highest refined capability */
-            ENETTRACE_WARN("PHY %u: falling back to manual mode\n", hPhy->addr);
-            state->enableNway = false;
-
-            commonLinkCaps = EnetPhy_findBestCap(commonLinkCaps);
-            ENETTRACE_WARN("PHY %u: new link caps: %s\n",
-                           hPhy->addr, EnetPhy_getCapsString(commonLinkCaps));
-            state->linkCaps = commonLinkCaps;
-        }
-    }
-
-    if (commonLinkCaps == 0U)
-    {
-        /* TODO: Should it go to a new "disabled" state where state machine doesn't run */
-        ENETTRACE_ERR("PHY %u: no supported caps found\n", hPhy->addr);
-    }
-    else if (state->loopbackEn)
-    {
-        ENETTRACE_DBG("PHY %u: setup loopback\n", hPhy->addr);
-        EnetPhy_setupManual(hPhy, true);
-        EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LOOPBACK);
-    }
-    else if (state->isNwayCapable && state->enableNway)
-    {
-        ENETTRACE_DBG("PHY %u: setup NWAY\n", hPhy->addr);
-        EnetPhy_setupNway(hPhy);
-        EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_NWAY_START);
-    }
-    else
-    {
-        ENETTRACE_DBG("PHY %u: manual setup\n", hPhy->addr);
-        EnetPhy_setupManual(hPhy, false);
-        EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINK_WAIT);
-    }
-}
-
-static void EnetPhy_setupNway(EnetPhy_Handle hPhy)
-{
-    EnetPhy_State *state = &hPhy->state;
-    uint16_t nwayAdvertise;
-    uint16_t nway1000Advertise = 0U;
-
-    ENETTRACE_DBG("PHY %u: NWAY advertising: %s\n",
-                  hPhy->addr, EnetPhy_getCapsString(state->linkCaps));
-
-    ENETTRACE_DBG("PHY %u: config is %sneeded\n",
-                  hPhy->addr, state->needsNwayCfg ? "" : "not ");
-
-    if (state->needsNwayCfg)
-    {
-        nwayAdvertise = ANAR_802P3;
-        if ((state->linkCaps & ENETPHY_LINK_CAP_FD100) != 0U)
-        {
-            nwayAdvertise |= ANAR_100FD;
-        }
-
-        if ((state->linkCaps & ENETPHY_LINK_CAP_HD100) != 0U)
-        {
-            nwayAdvertise |= ANAR_100HD;
-        }
-
-        if ((state->linkCaps & ENETPHY_LINK_CAP_FD10) != 0U)
-        {
-            nwayAdvertise |= ANAR_10FD;
-        }
-
-        if ((state->linkCaps & ENETPHY_LINK_CAP_HD10) != 0U)
-        {
-            nwayAdvertise |= ANAR_10HD;
-        }
-
-        if ((state->linkCaps & ENETPHY_LINK_CAP_FD1000) != 0U)
-        {
-            nway1000Advertise |= GIGCR_1000FD;
-        }
-
-        if ((state->linkCaps & ENETPHY_LINK_CAP_HD1000) != 0U)
-        {
-            nway1000Advertise |= GIGCR_1000HD;
-        }
-
-        EnetPhy_rmwReg(hPhy, PHY_ANAR, ANAR_100 | ANAR_10, nwayAdvertise);
-
-        if ((state->phyLinkCaps & ENETPHY_LINK_CAP_1000) != 0U)
-        {
-            EnetPhy_rmwReg(hPhy, PHY_GIGCR, GIGCR_1000, nway1000Advertise);
-        }
-
-        state->needsNwayCfg = false;
-    }
-
-    /* Restart auto-negotiation */
-    ENETTRACE_DBG("PHY %u: restart autonegotiation\n", hPhy->addr);
-    EnetPhy_rmwReg(hPhy, PHY_BMCR, BMCR_ANEN, BMCR_ANEN);
-
-    /* TODO: is MII_ENETPHY_FD needed for auto-negotiation? */
-    EnetPhy_rmwReg(hPhy, PHY_BMCR,
-                   BMCR_ANRESTART | BMCR_FD,
-                   BMCR_ANRESTART | BMCR_FD);
-}
-
-static void EnetPhy_setupManual(EnetPhy_Handle hPhy,
-                                bool loopbackEn)
-{
-    EnetPhy_State *state = &hPhy->state;
-    uint16_t val;
-
-    /* Manual config is needed if entered the FOUND state for the first time
-     * or if an explicit mode change was requested via EnetPhy_setPhyMode() */
-    if (state->needsManualCfg)
-    {
-        /* Disable auto-negotiation if supported by PHY */
-        if (state->isNwayCapable)
-        {
-            ENETTRACE_DBG("PHY %u: disable NWAY\n", hPhy->addr);
-            EnetPhy_rmwReg(hPhy, PHY_BMCR, BMCR_ANEN, 0U);
-        }
-
-        switch (state->linkCaps)
-        {
-            case ENETPHY_LINK_CAP_FD1000:
-                val = BMCR_SPEED1000 | BMCR_FD;
-                break;
-
-            case ENETPHY_LINK_CAP_HD1000:
-                val = BMCR_SPEED1000;
-                break;
-
-            case ENETPHY_LINK_CAP_FD100:
-                val = BMCR_SPEED100 | BMCR_FD;
-                break;
-
-            case ENETPHY_LINK_CAP_HD100:
-                val = BMCR_SPEED100;
-                break;
-
-            case ENETPHY_LINK_CAP_FD10:
-                val = BMCR_FD;
-                break;
-
-            case ENETPHY_LINK_CAP_HD10:
-            default:
-                val = 0U;
-                break;
-        }
-
-        if (loopbackEn)
-        {
-            val |= BMCR_LOOPBACK;
+            if ((hPhy->hDrv->config != NULL))
+            {
+            	if(0 == hPhy->hDrv->config(hPhy, &hPhy->phyCfg, hPhy->mii))
+            	{
+            		EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_NWAY_START);
+            	}
+            	else
+            	{
+            		EnetUtils_printf("============+++PHY= %d =config error \n",hPhy->addr);
+
+            	}
+            }
         }
-
-        EnetPhy_rmwReg(hPhy, PHY_BMCR,
-                       BMCR_LOOPBACK | BMCR_SPEED1000 | BMCR_SPEED100 | BMCR_FD,
-                       val);
-
-        /* Clear advertised capabilities values if supported */
-        if (state->isNwayCapable)
+        else
         {
-            EnetPhy_rmwReg(hPhy, PHY_ANAR, ANAR_100 | ANAR_10, 0U);
-
-            if ((state->phyLinkCaps & ENETPHY_LINK_CAP_1000) != 0U)
+        	EnetPhy_rmwReg(hPhy, PHY_BMCR, BMCR_ISOLATE | BMCR_PWRDOWN, 0U);
+            if ((hPhy->hDrv->config != NULL) &&
+                !hPhy->phyCfg.skipExtendedCfg)
             {
-                EnetPhy_rmwReg(hPhy, PHY_GIGCR, GIGCR_1000, 0U);
+                hPhy->hDrv->config(hPhy, &hPhy->phyCfg, hPhy->mii);
             }
         }
 
-        state->needsManualCfg = false;
     }
+}
 
-    EnetPhy_capToMode(state->linkCaps, &state->speed, &state->duplexity);
 
-    ENETTRACE_DBG("PHY %u: requested mode: %s\n",
-                  hPhy->addr, EnetPhy_getModeString(state->speed, state->duplexity));
-}
 
 static void EnetPhy_loopbackState(EnetPhy_Handle hPhy)
 {
@@ -1319,28 +1233,35 @@ static void EnetPhy_nwayStartState(EnetPhy_Handle hPhy)
     EnetPhy_State *state = &hPhy->state;
     uint16_t mode;
     uint16_t val;
-
-    Enet_devAssert(!hPhy->phyCfg.isStrapped,
-                   "PHY %u: unexpected state for strapped PHY\n", hPhy->addr);
-
-    /* Wait for NWAY to start */
-    EnetPhy_readReg(hPhy, PHY_BMCR, &mode);
-
-    if ((mode & BMCR_ANRESTART) == 0U)
+    if(EnetPhy_PhyAddrIsQ2112(hPhy->addr))
     {
-        /* Flush pending latch bits */
-        EnetPhy_readReg(hPhy, PHY_BMSR, &val);
-        EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_NWAY_WAIT);
+    	EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_NWAY_WAIT);
     }
     else
     {
-        if (state->timeout != 0U)
+        Enet_devAssert(!hPhy->phyCfg.isStrapped,
+                       "PHY %u: unexpected state for strapped PHY\n", hPhy->addr);
+
+        /* Wait for NWAY to start */
+        EnetPhy_readReg(hPhy, PHY_BMCR, &mode);
+
+        if ((mode & BMCR_ANRESTART) == 0U)
         {
-            state->timeout--;
+            /* Flush pending latch bits */
+            EnetPhy_readReg(hPhy, PHY_BMSR, &val);
+            EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_NWAY_WAIT);
         }
         else
         {
-            EnetPhy_phyTimeout(hPhy);
+            if (state->timeout != 0U)
+            {
+                state->timeout--;
+            }
+            else
+            {
+            	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
+                EnetPhy_phyTimeout(hPhy);
+            }
         }
     }
 }
@@ -1351,41 +1272,82 @@ static void EnetPhy_nwayWaitState(EnetPhy_Handle hPhy)
     uint32_t nwayCaps;
     uint16_t status;
 
-    Enet_devAssert(!hPhy->phyCfg.isStrapped,
-                   "PHY %u: unexpected state for strapped PHY\n", hPhy->addr);
-
-    EnetPhy_readReg(hPhy, PHY_BMSR, &status);
-    if (0U != (status & BMSR_ANCOMPLETE))
-    {
-        nwayCaps = EnetPhy_findCommonNwayCaps(hPhy);
-        if (nwayCaps != 0U)
+    if(EnetPhy_PhyAddrIsQ2112(hPhy->addr))
+    {
+    	if(checkLink(hPhy))
+    	{
+   		    // ENETTRACE_VERBOSE("PHY= %d timer %d LINE::%d \n",hPhy->addr,state->timeout,__LINE__);
+    		EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
+            EnetPhy_capToMode(ENETPHY_LINK_CAP_FD1000, &state->speed, &state->duplexity);
+    		ENETTRACE_DBG("%s  :PHY= %d =linked mode=%s, linkCaps=%s\n",__FUNCTION__,hPhy->addr, 
+                EnetPhy_getModeString(state->speed, state->duplexity), EnetPhy_getCapsString(state->linkCaps));
+    		return ;
+    	}
+    	else
+    	{
+            ENETTRACE_VERBOSE("%s  :PHY= %d =NOT LINKED \n",__FUNCTION__,hPhy->addr);
+    		EnetPhy_FsmState phystate = q2112_nwayWait(hPhy);
+    		if(ENETPHY_FSM_STATE_NWAY_WAIT != phystate)
+    		{
+        		nwayCaps = ENETPHY_LINK_CAP_FD1000;
+        		EnetPhy_capToMode(nwayCaps, &state->speed, &state->duplexity);
+        		EnetUtils_printf("PHY= %d =Jumping to %d \n",hPhy->addr,phystate);
+        		EnetPhy_setNextState(hPhy, phystate);
+    		}
+    	}
+        if (state->timeout != 0U)
         {
-            EnetPhy_capToMode(nwayCaps, &state->speed, &state->duplexity);
-
-            ENETTRACE_DBG("PHY %u: negotiated mode: %s\n",
-                          hPhy->addr, EnetPhy_getModeString(state->speed, state->duplexity));
+//        	EnetUtils_printf("PHY= %d timer %d \n",hPhy->addr,state->timeout);
+            state->timeout--;
+        }
+        else
+        {
+        	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
 
-            if ((status & BMSR_LINKSTS) != 0U)
-            {
-                EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
-            }
-            else
-            {
-                EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINK_WAIT);
-            }
+            EnetPhy_phyTimeout(hPhy);
         }
     }
     else
     {
-        if (state->timeout != 0U)
+        Enet_devAssert(!hPhy->phyCfg.isStrapped,
+                       "PHY %u: unexpected state for strapped PHY\n", hPhy->addr);
+
+        EnetPhy_readReg(hPhy, PHY_BMSR, &status);
+        if (0U != (status & BMSR_ANCOMPLETE))
         {
-            state->timeout--;
+            nwayCaps = EnetPhy_findCommonNwayCaps(hPhy);
+            if (nwayCaps != 0U)
+            {
+                EnetPhy_capToMode(nwayCaps, &state->speed, &state->duplexity);
+
+                ENETTRACE_DBG("PHY %u: negotiated mode: %s\n",
+                              hPhy->addr, __FUNCTION__);
+
+                if ((status & BMSR_LINKSTS) != 0U)
+                {
+                    EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
+                }
+                else
+                {
+                    EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINK_WAIT);
+                }
+            }
         }
         else
         {
-            EnetPhy_phyTimeout(hPhy);
+            if (state->timeout != 0U)
+            {
+                state->timeout--;
+            }
+            else
+            {
+            	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
+
+                EnetPhy_phyTimeout(hPhy);
+            }
         }
     }
+
 }
 
 static void EnetPhy_linkWaitState(EnetPhy_Handle hPhy)
@@ -1394,37 +1356,67 @@ static void EnetPhy_linkWaitState(EnetPhy_Handle hPhy)
     uint32_t nwayCaps;
     uint16_t status;
 
-    EnetPhy_readReg(hPhy, PHY_BMSR, &status);
-
-    if ((status & BMSR_LINKSTS) != 0U)
+    if(EnetPhy_PhyAddrIsQ2112(hPhy->addr))
     {
-        /* Populate FSM state now as most FSM states are bypassed for strapped PHYs */
-        if (hPhy->phyCfg.isStrapped)
-        {
-            state->phyLinkCaps = EnetPhy_getLocalCaps(hPhy);
-            nwayCaps = EnetPhy_findCommonNwayCaps(hPhy);
-            if (nwayCaps != 0U)
-            {
-                EnetPhy_capToMode(nwayCaps, &state->speed, &state->duplexity);
+    	if(checkLink(hPhy))
+    	{
+    		EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
+//    		EnetUtils_printf("%s  :PHY= %d =linked \n",__FUNCTION__,hPhy->addr);
 
-                ENETTRACE_DBG("PHY %u: negotiated mode: %s\n",
-                              hPhy->addr, EnetPhy_getModeString(state->speed, state->duplexity));
+    	}
+    	else
+    	{
+    		EnetUtils_printf("============+++PHY= %d =linked timeout \n",hPhy->addr);
+
+            if (state->timeout != 0U)
+            {
+                state->timeout--;
             }
-        }
+            else
+            {
+            	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
 
-        EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
+                EnetPhy_phyTimeout(hPhy);
+            }
+    	}
     }
     else
     {
-        if (state->timeout != 0U)
+        EnetPhy_readReg(hPhy, PHY_BMSR, &status);
+
+        if ((status & BMSR_LINKSTS) != 0U)
         {
-            state->timeout--;
+            /* Populate FSM state now as most FSM states are bypassed for strapped PHYs */
+            if (hPhy->phyCfg.isStrapped)
+            {
+                state->phyLinkCaps = EnetPhy_getLocalCaps(hPhy);
+                nwayCaps = EnetPhy_findCommonNwayCaps(hPhy);
+                if (nwayCaps != 0U)
+                {
+                    EnetPhy_capToMode(nwayCaps, &state->speed, &state->duplexity);
+
+                    ENETTRACE_DBG("PHY %u: negotiated mode: %s\n",
+                                  hPhy->addr, __FUNCTION__);
+                }
+            }
+
+            EnetPhy_setNextState(hPhy, ENETPHY_FSM_STATE_LINKED);
         }
         else
         {
-            EnetPhy_phyTimeout(hPhy);
+            if (state->timeout != 0U)
+            {
+                state->timeout--;
+            }
+            else
+            {
+            	ENETTRACE_DBG("PHY %u: FUCNTION::%s LINE:: %d\n", hPhy->addr,__FUNCTION__,__LINE__);
+
+                EnetPhy_phyTimeout(hPhy);
+            }
         }
     }
+
 }
 
 static void EnetPhy_linkedState(EnetPhy_Handle hPhy)
@@ -1447,57 +1439,53 @@ static void EnetPhy_linkedState(EnetPhy_Handle hPhy)
     }
 }
 
-
-static bool EnetPhy_isNwayCapable(EnetPhy_Handle hPhy)
-{
-    uint16_t val = 0U;
-
-    /* Get the PHY Status */
-    EnetPhy_readReg(hPhy, PHY_BMSR, &val);
-
-    return ((val & BMSR_ANCAPABLE) != 0U);
-}
-
 static uint32_t EnetPhy_getLocalCaps(EnetPhy_Handle hPhy)
 {
     uint32_t caps = 0U;
     uint16_t val  = 0U;
 
-    /* Get 10/100 Mbps capabilities */
-    EnetPhy_readReg(hPhy, PHY_BMSR, &val);
-    if ((val & BMSR_100FD) != 0U)
-    {
-        caps |= ENETPHY_LINK_CAP_FD100;
-    }
-
-    if ((val & BMSR_100HD) != 0U)
+    if(EnetPhy_PhyAddrIsQ2112(hPhy->addr))
     {
-        caps |= ENETPHY_LINK_CAP_HD100;
+    	caps |= ENETPHY_LINK_CAP_FD1000;
     }
-
-    if ((val & BMSR_10FD) != 0U)
+    else
     {
-        caps |= ENETPHY_LINK_CAP_FD10;
-    }
+        /* Get 10/100 Mbps capabilities */
+        EnetPhy_readReg(hPhy, PHY_BMSR, &val);
+        if ((val & BMSR_100FD) != 0U)
+        {
+            caps |= ENETPHY_LINK_CAP_FD100;
+        }
 
-    if ((val & BMSR_10HD) != 0U)
-    {
-        caps |= ENETPHY_LINK_CAP_HD10;
-    }
+        if ((val & BMSR_100HD) != 0U)
+        {
+            caps |= ENETPHY_LINK_CAP_HD100;
+        }
 
-    /* Get extended (1 Gbps) capabilities if supported */
-    if ((val & BMSR_GIGEXTSTS) != 0U)
-    {
-        EnetPhy_readReg(hPhy, PHY_GIGESR, &val);
+        if ((val & BMSR_10FD) != 0U)
+        {
+            caps |= ENETPHY_LINK_CAP_FD10;
+        }
 
-        if ((val & GIGESR_1000FD) != 0U)
+        if ((val & BMSR_10HD) != 0U)
         {
-            caps |= ENETPHY_LINK_CAP_FD1000;
+            caps |= ENETPHY_LINK_CAP_HD10;
         }
 
-        if ((val & GIGESR_1000HD) != 0U)
+        /* Get extended (1 Gbps) capabilities if supported */
+        if ((val & BMSR_GIGEXTSTS) != 0U)
         {
-            caps |= ENETPHY_LINK_CAP_HD1000;
+            EnetPhy_readReg(hPhy, PHY_GIGESR, &val);
+
+            if ((val & GIGESR_1000FD) != 0U)
+            {
+                caps |= ENETPHY_LINK_CAP_FD1000;
+            }
+
+            if ((val & GIGESR_1000HD) != 0U)
+            {
+                caps |= ENETPHY_LINK_CAP_HD1000;
+            }
         }
     }
 
